import { App, Component } from 'vue';
import { CustomCompData, FormItemData, PreDefineCompData } from './types';
interface SmartForm {
    predefinedComponents: Map<string, Component>;
    install: (app: App) => void;
}
export declare function createSmartForm(): SmartForm;
export declare const setActiveSmartForm: (s: SmartForm) => void;
export declare const getActiveSmartForm: () => SmartForm;
type Comp = {
    component: Component;
    modelValueKey?: string;
};
export declare const defineFormType: <A extends string, C extends Component>(alias: A, comp: C) => (options: POptions<A, C>) => PreDefineCompData<A, C>;
export declare const defineFormTypes: <C extends Record<string, Comp>>(compMap: C) => () => <T extends keyof C & string>(options: (POptions<T, C[T]['component']> | CustomCompData)[]) => FormItemData[];
export type POptions<A extends string, C = any> = Omit<PreDefineCompData<A, C>, 'component' | 'type'>;
export {};
