import { InjectionKey, Ref } from 'vue';
import { FormItemData } from './types';
export type SmartFormState = {
    emit: {
        (name: 'itemChange', id: string, value: any, prev: any, itemData: FormItemData, ctx?: any): void;
    };
    el: Ref<HTMLElement | null>;
    labelWidth: Ref<string>;
    labelPosition: Ref<LabelPoistion>;
    itemClass: Ref<string | undefined>;
    modelValue: Ref<Record<string, any>>;
    rules: Ref<Record<string, any>>;
};
export type LabelPoistion = 'left' | 'top' | 'sticky' | 'none';
export declare const SMART_FORM_STATE: InjectionKey<SmartFormState>;
export declare const provideFormState: (s: SmartFormState) => SmartFormState;
export declare const useSmartFormState: () => SmartFormState;
