import { InjectionKey, provide, inject } from 'vue'
import { FormItemData } from '../types'

export type FormItemState = {
  el: HTMLElement | null
  shake: () => void
  item: FormItemData
}
export const FORM_ITEM_STATE: InjectionKey<FormItemState> =
  Symbol('FORM_ITEM_STATE')

export const provideFormItemState = (s: FormItemState) => {
  provide(FORM_ITEM_STATE, s)
  return s
}

export const useFormItemState = () => inject(FORM_ITEM_STATE)!
