import type { Rule, RuleItem } from 'async-validator'

export function sleep(time: number): Promise<void> {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      resolve()
    }, time)
  })
}


export function mergeRules(...rules: (Rule | undefined)[]) {
  return rules.reduce<RuleItem[]>((res, cur) => {
    if (Array.isArray(cur)) {
      return res.concat(cur)
    } else if (cur && Object.keys(cur).length) {
      res.push(cur)
    }
    return res
  }, [])
}